import 'package:flutter/cupertino.dart';
import 'package:flutter/material.dart';
import 'package:provider/provider.dart';
import 'package:tencent_im_sdk_plugin/models/v2_tim_message.dart';
import 'package:tencent_im_sdk_plugin/models/v2_tim_value_callback.dart';
import 'package:tencent_im_sdk_plugin/tencent_im_sdk_plugin.dart';
import 'package:tencent_im_sdk_plugin_example/provider/currentMessageList.dart';

List<Map<String, Object>> emojiData = [
  {"name": "GRINNING FACE WITH SMILING EYES", "unicode": 128513},
  {"name": "FACE WITH TEARS OF JOY", "unicode": 128514},
  {"name": "SMILING FACE WITH OPEN MOUTH", "unicode": 128515},
  {"name": "SMILING FACE WITH OPEN MOUTH AND SMILING EYES", "unicode": 128516},
  {"name": "SMILING FACE WITH OPEN MOUTH AND COLD SWEAT", "unicode": 128517},
  {
    "name": "SMILING FACE WITH OPEN MOUTH AND TIGHTLY-CLOSED EYES",
    "unicode": 128518
  },
  {"name": "WINKING FACE", "unicode": 128521},
  {"name": "SMILING FACE WITH SMILING EYES", "unicode": 128522},
  {"name": "FACE SAVOURING DELICIOUS FOOD", "unicode": 128523},
  {"name": "RELIEVED FACE", "unicode": 128524},
  {"name": "SMILING FACE WITH HEART-SHAPED EYES", "unicode": 128525},
  {"name": "SMIRKING FACE", "unicode": 128527},
  {"name": "UNAMUSED FACE", "unicode": 128530},
  {"name": "FACE WITH COLD SWEAT", "unicode": 128531},
  {"name": "PENSIVE FACE", "unicode": 128532},
  {"name": "CONFOUNDED FACE", "unicode": 128534},
  {"name": "FACE THROWING A KISS", "unicode": 128536},
  {"name": "KISSING FACE WITH CLOSED EYES", "unicode": 128538},
  {"name": "FACE WITH STUCK-OUT TONGUE AND WINKING EYE", "unicode": 128540},
  {
    "name": "FACE WITH STUCK-OUT TONGUE AND TIGHTLY-CLOSED EYES",
    "unicode": 128541
  },
  {"name": "DISAPPOINTED FACE", "unicode": 128542},
  {"name": "ANGRY FACE", "unicode": 128544},
  {"name": "POUTING FACE", "unicode": 128545},
  {"name": "CRYING FACE", "unicode": 128546},
  {"name": "PERSEVERING FACE", "unicode": 128547},
  {"name": "FACE WITH LOOK OF TRIUMPH", "unicode": 128548},
  {"name": "DISAPPOINTED BUT RELIEVED FACE", "unicode": 128549},
  {"name": "FEARFUL FACE", "unicode": 128552},
  {"name": "WEARY FACE", "unicode": 128553},
  {"name": "SLEEPY FACE", "unicode": 128554},
  {"name": "TIRED FACE", "unicode": 128555},
  {"name": "LOUDLY CRYING FACE", "unicode": 128557},
  {"name": "FACE WITH OPEN MOUTH AND COLD SWEAT", "unicode": 128560},
  {"name": "FACE SCREAMING IN FEAR", "unicode": 128561},
  {"name": "ASTONISHED FACE", "unicode": 128562},
  {"name": "FLUSHED FACE", "unicode": 128563},
  {"name": "DIZZY FACE", "unicode": 128565},
  {"name": "FACE WITH MEDICAL MASK", "unicode": 128567},
  {"name": "GRINNING CAT FACE WITH SMILING EYES", "unicode": 128568},
  {"name": "CAT FACE WITH TEARS OF JOY", "unicode": 128569},
  {"name": "SMILING CAT FACE WITH OPEN MOUTH", "unicode": 128570},
  {"name": "SMILING CAT FACE WITH HEART-SHAPED EYES", "unicode": 128571},
  {"name": "CAT FACE WITH WRY SMILE", "unicode": 128572},
  {"name": "KISSING CAT FACE WITH CLOSED EYES", "unicode": 128573},
  {"name": "POUTING CAT FACE", "unicode": 128574},
  {"name": "CRYING CAT FACE", "unicode": 128575},
  {"name": "WEARY CAT FACE", "unicode": 128576},
  {"name": "FACE WITH NO GOOD GESTURE", "unicode": 128581},
  {"name": "FACE WITH OK GESTURE", "unicode": 128582},
  {"name": "PERSON BOWING DEEPLY", "unicode": 128583},
  {"name": "SEE-NO-EVIL MONKEY", "unicode": 128584},
  {"name": "HEAR-NO-EVIL MONKEY", "unicode": 128585},
  {"name": "SPEAK-NO-EVIL MONKEY", "unicode": 128586},
  {"name": "HAPPY PERSON RAISING ONE HAND", "unicode": 128587},
  {"name": "PERSON RAISING BOTH HANDS IN CELEBRATION", "unicode": 128588},
  {"name": "PERSON FROWNING", "unicode": 128589},
  {"name": "PERSON WITH POUTING FACE", "unicode": 128590},
  {"name": "PERSON WITH FOLDED HANDS", "unicode": 128591},
  {"name": "BLACK SCISSORS", "unicode": 9986},
  {"name": "WHITE HEAVY CHECK MARK", "unicode": 9989},
  {"name": "AIRPLANE", "unicode": 9992},
  {"name": "ENVELOPE", "unicode": 9993},
  {"name": "RAISED FIST", "unicode": 9994},
  {"name": "RAISED HAND", "unicode": 9995},
  {"name": "VICTORY HAND", "unicode": 9996},
  {"name": "PENCIL", "unicode": 9999},
  {"name": "BLACK NIB", "unicode": 10002},
  {"name": "HEAVY CHECK MARK", "unicode": 10004},
  {"name": "HEAVY MULTIPLICATION X", "unicode": 10006},
  {"name": "SPARKLES", "unicode": 10024},
  {"name": "EIGHT SPOKED ASTERISK", "unicode": 10035},
  {"name": "EIGHT POINTED BLACK STAR", "unicode": 10036},
  {"name": "SNOWFLAKE", "unicode": 10052},
  {"name": "SPARKLE", "unicode": 10055},
  {"name": "CROSS MARK", "unicode": 10060},
  {"name": "NEGATIVE SQUARED CROSS MARK", "unicode": 10062},
  {"name": "BLACK QUESTION MARK ORNAMENT", "unicode": 10067},
  {"name": "WHITE QUESTION MARK ORNAMENT", "unicode": 10068},
  {"name": "WHITE EXCLAMATION MARK ORNAMENT", "unicode": 10069},
  {"name": "HEAVY EXCLAMATION MARK SYMBOL", "unicode": 10071},
  {"name": "HEAVY BLACK HEART", "unicode": 10084},
  {"name": "HEAVY PLUS SIGN", "unicode": 10133},
  {"name": "HEAVY MINUS SIGN", "unicode": 10134},
  {"name": "HEAVY DIVISION SIGN", "unicode": 10135},
  {"name": "BLACK RIGHTWARDS ARROW", "unicode": 10145},
  {"name": "CURLY LOOP", "unicode": 10160},
  {"name": "ROCKET", "unicode": 128640},
  {"name": "RAILWAY CAR", "unicode": 128643},
  {"name": "HIGH-SPEED TRAIN", "unicode": 128644},
  {"name": "HIGH-SPEED TRAIN WITH BULLET NOSE", "unicode": 128645},
  {"name": "METRO", "unicode": 128647},
  {"name": "STATION", "unicode": 128649},
  {"name": "BUS", "unicode": 128652},
  {"name": "BUS STOP", "unicode": 128655},
  {"name": "AMBULANCE", "unicode": 128657},
  {"name": "FIRE ENGINE", "unicode": 128658},
  {"name": "POLICE CAR", "unicode": 128659},
  {"name": "TAXI", "unicode": 128661},
  {"name": "AUTOMOBILE", "unicode": 128663},
  {"name": "RECREATIONAL VEHICLE", "unicode": 128665},
  {"name": "DELIVERY TRUCK", "unicode": 128666},
  {"name": "SHIP", "unicode": 128674},
  {"name": "SPEEDBOAT", "unicode": 128676},
  {"name": "HORIZONTAL TRAFFIC LIGHT", "unicode": 128677},
  {"name": "CONSTRUCTION SIGN", "unicode": 128679},
  {"name": "POLICE CARS REVOLVING LIGHT", "unicode": 128680},
  {"name": "TRIANGULAR FLAG ON POST", "unicode": 128681},
  {"name": "DOOR", "unicode": 128682},
  {"name": "NO ENTRY SIGN", "unicode": 128683},
  {"name": "SMOKING SYMBOL", "unicode": 128684},
  {"name": "NO SMOKING SYMBOL", "unicode": 128685},
  {"name": "BICYCLE", "unicode": 128690},
  {"name": "PEDESTRIAN", "unicode": 128694},
  {"name": "MENS SYMBOL", "unicode": 128697},
  {"name": "WOMENS SYMBOL", "unicode": 128698},
  {"name": "RESTROOM", "unicode": 128699},
  {"name": "BABY SYMBOL", "unicode": 128700},
  {"name": "TOILET", "unicode": 128701},
  {"name": "WATER CLOSET", "unicode": 128702},
  {"name": "BATH", "unicode": 128704},
  {"name": "CIRCLED LATIN CAPITAL LETTER M", "unicode": 9410},
  {"name": "NEGATIVE SQUARED LATIN CAPITAL LETTER A", "unicode": 127344},
  {"name": "NEGATIVE SQUARED LATIN CAPITAL LETTER B", "unicode": 127345},
  {"name": "NEGATIVE SQUARED LATIN CAPITAL LETTER O", "unicode": 127358},
  {"name": "NEGATIVE SQUARED LATIN CAPITAL LETTER P", "unicode": 127359},
  {"name": "NEGATIVE SQUARED AB", "unicode": 127374},
  {"name": "SQUARED CL", "unicode": 127377},
  {"name": "SQUARED COOL", "unicode": 127378},
  {"name": "SQUARED FREE", "unicode": 127379},
  {"name": "SQUARED ID", "unicode": 127380},
  {"name": "SQUARED NEW", "unicode": 127381},
  // {"name": "SQUARED NG", "unicode": 127382},
  // {"name": "SQUARED OK", "unicode": 127383},
  // {"name": "SQUARED SOS", "unicode": 127384},
  // {"name": "SQUARED UP WITH EXCLAMATION MARK", "unicode": 127385},
  // {"name": "SQUARED VS", "unicode": 127386},
  // {"name": "SQUARED KATAKANA KOKO", "unicode": 127489},
  // {"name": "SQUARED KATAKANA SA", "unicode": 127490},
  // {"name": "SQUARED CJK UNIFIED IDEOGRAPH-7121", "unicode": 127514},
  // {"name": "SQUARED CJK UNIFIED IDEOGRAPH-6307", "unicode": 127535},
  // {"name": "SQUARED CJK UNIFIED IDEOGRAPH-7981", "unicode": 127538},
  // {"name": "SQUARED CJK UNIFIED IDEOGRAPH-7A7A", "unicode": 127539},
  // {"name": "SQUARED CJK UNIFIED IDEOGRAPH-5408", "unicode": 127540},
  // {"name": "SQUARED CJK UNIFIED IDEOGRAPH-6E80", "unicode": 127541},
  // {"name": "SQUARED CJK UNIFIED IDEOGRAPH-6709", "unicode": 127542},
  // {"name": "SQUARED CJK UNIFIED IDEOGRAPH-6708", "unicode": 127543},
  // {"name": "SQUARED CJK UNIFIED IDEOGRAPH-7533", "unicode": 127544},
  // {"name": "SQUARED CJK UNIFIED IDEOGRAPH-5272", "unicode": 127545},
  // {"name": "SQUARED CJK UNIFIED IDEOGRAPH-55B6", "unicode": 127546},
  // {"name": "CIRCLED IDEOGRAPH ADVANTAGE", "unicode": 127568},
  // {"name": "CIRCLED IDEOGRAPH ACCEPT", "unicode": 127569},
  // {"name": "COPYRIGHT SIGN", "unicode": 169},
  // {"name": "REGISTERED SIGN", "unicode": 174},
  // {"name": "DOUBLE EXCLAMATION MARK", "unicode": 8252},
  // {"name": "EXCLAMATION QUESTION MARK", "unicode": 8265},
  // {"name": "TRADE MARK SIGN", "unicode": 8482},
  // {"name": "INFORMATION SOURCE", "unicode": 8505},
  // {"name": "LEFT RIGHT ARROW", "unicode": 8596},
  // {"name": "UP DOWN ARROW", "unicode": 8597},
  // {"name": "NORTH WEST ARROW", "unicode": 8598},
  // {"name": "NORTH EAST ARROW", "unicode": 8599},
  // {"name": "SOUTH EAST ARROW", "unicode": 8600},
  // {"name": "SOUTH WEST ARROW", "unicode": 8601},
  // {"name": "LEFTWARDS ARROW WITH HOOK", "unicode": 8617},
  // {"name": "RIGHTWARDS ARROW WITH HOOK", "unicode": 8618},
  // {"name": "WATCH", "unicode": 8986},
  // {"name": "HOURGLASS", "unicode": 8987},
  // {"name": "BLACK RIGHT-POINTING DOUBLE TRIANGLE", "unicode": 9193},
  // {"name": "BLACK LEFT-POINTING DOUBLE TRIANGLE", "unicode": 9194},
  // {"name": "BLACK UP-POINTING DOUBLE TRIANGLE", "unicode": 9195},
  // {"name": "BLACK DOWN-POINTING DOUBLE TRIANGLE", "unicode": 9196},
  // {"name": "ALARM CLOCK", "unicode": 9200},
  // {"name": "HOURGLASS WITH FLOWING SAND", "unicode": 9203},
  // {"name": "BLACK SMALL SQUARE", "unicode": 9642},
  // {"name": "WHITE SMALL SQUARE", "unicode": 9643},
  // {"name": "BLACK RIGHT-POINTING TRIANGLE", "unicode": 9654},
  // {"name": "BLACK LEFT-POINTING TRIANGLE", "unicode": 9664},
  // {"name": "WHITE MEDIUM SQUARE", "unicode": 9723},
  // {"name": "BLACK MEDIUM SQUARE", "unicode": 9724},
  // {"name": "WHITE MEDIUM SMALL SQUARE", "unicode": 9725},
  // {"name": "BLACK MEDIUM SMALL SQUARE", "unicode": 9726},
  // {"name": "BLACK SUN WITH RAYS", "unicode": 9728},
  // {"name": "CLOUD", "unicode": 9729},
  // {"name": "BLACK TELEPHONE", "unicode": 9742},
  // {"name": "BALLOT BOX WITH CHECK", "unicode": 9745},
  // {"name": "UMBRELLA WITH RAIN DROPS", "unicode": 9748},
  // {"name": "HOT BEVERAGE", "unicode": 9749},
  // {"name": "WHITE UP POINTING INDEX", "unicode": 9757},
  // {"name": "WHITE SMILING FACE", "unicode": 9786},
  // {"name": "ARIES", "unicode": 9800},
  // {"name": "TAURUS", "unicode": 9801},
  // {"name": "GEMINI", "unicode": 9802},
  // {"name": "CANCER", "unicode": 9803},
  // {"name": "LEO", "unicode": 9804},
  // {"name": "VIRGO", "unicode": 9805},
  // {"name": "LIBRA", "unicode": 9806},
  // {"name": "SCORPIUS", "unicode": 9807},
  // {"name": "SAGITTARIUS", "unicode": 9808},
  // {"name": "CAPRICORN", "unicode": 9809},
  // {"name": "AQUARIUS", "unicode": 9810},
  // {"name": "PISCES", "unicode": 9811},
  // {"name": "BLACK SPADE SUIT", "unicode": 9824},
  // {"name": "BLACK CLUB SUIT", "unicode": 9827},
  // {"name": "BLACK HEART SUIT", "unicode": 9829},
  // {"name": "BLACK DIAMOND SUIT", "unicode": 9830},
  // {"name": "HOT SPRINGS", "unicode": 9832},
  // {"name": "BLACK UNIVERSAL RECYCLING SYMBOL", "unicode": 9851},
  // {"name": "WHEELCHAIR SYMBOL", "unicode": 9855},
  // {"name": "ANCHOR", "unicode": 9875},
  // {"name": "WARNING SIGN", "unicode": 9888},
  // {"name": "HIGH VOLTAGE SIGN", "unicode": 9889},
  // {"name": "MEDIUM WHITE CIRCLE", "unicode": 9898},
  // {"name": "MEDIUM BLACK CIRCLE", "unicode": 9899},
  // {"name": "SOCCER BALL", "unicode": 9917},
  // {"name": "BASEBALL", "unicode": 9918},
  // {"name": "SNOWMAN WITHOUT SNOW", "unicode": 9924},
  // {"name": "SUN BEHIND CLOUD", "unicode": 9925},
  // {"name": "OPHIUCHUS", "unicode": 9934},
  // {"name": "NO ENTRY", "unicode": 9940},
  // {"name": "CHURCH", "unicode": 9962},
  // {"name": "FOUNTAIN", "unicode": 9970},
  // {"name": "FLAG IN HOLE", "unicode": 9971},
  // {"name": "SAILBOAT", "unicode": 9973},
  // {"name": "TENT", "unicode": 9978},
  // {"name": "FUEL PUMP", "unicode": 9981},
  // {"name": "ARROW POINTING RIGHTWARDS THEN CURVING UPWARDS", "unicode": 10548},
  // {
  //   "name": "ARROW POINTING RIGHTWARDS THEN CURVING DOWNWARDS",
  //   "unicode": 10549
  // },
  // {"name": "LEFTWARDS BLACK ARROW", "unicode": 11013},
  // {"name": "UPWARDS BLACK ARROW", "unicode": 11014},
  // {"name": "DOWNWARDS BLACK ARROW", "unicode": 11015},
  // {"name": "BLACK LARGE SQUARE", "unicode": 11035},
  // {"name": "WHITE LARGE SQUARE", "unicode": 11036},
  // {"name": "WHITE MEDIUM STAR", "unicode": 11088},
  // {"name": "HEAVY LARGE CIRCLE", "unicode": 11093},
  // {"name": "WAVY DASH", "unicode": 12336},
  // {"name": "PART ALTERNATION MARK", "unicode": 12349},
  // {"name": "CIRCLED IDEOGRAPH CONGRATULATION", "unicode": 12951},
  // {"name": "CIRCLED IDEOGRAPH SECRET", "unicode": 12953},
  // {"name": "MAHJONG TILE RED DRAGON", "unicode": 126980},
  // {"name": "PLAYING CARD BLACK JOKER", "unicode": 127183},
  // {"name": "CYCLONE", "unicode": 127744},
  // {"name": "FOGGY", "unicode": 127745},
  // {"name": "CLOSED UMBRELLA", "unicode": 127746},
  // {"name": "NIGHT WITH STARS", "unicode": 127747},
  // {"name": "SUNRISE OVER MOUNTAINS", "unicode": 127748},
  // {"name": "SUNRISE", "unicode": 127749},
  // {"name": "CITYSCAPE AT DUSK", "unicode": 127750},
  // {"name": "SUNSET OVER BUILDINGS", "unicode": 127751},
  // {"name": "RAINBOW", "unicode": 127752},
  // {"name": "BRIDGE AT NIGHT", "unicode": 127753},
  // {"name": "WATER WAVE", "unicode": 127754},
  // {"name": "VOLCANO", "unicode": 127755},
  // {"name": "MILKY WAY", "unicode": 127756},
  // {"name": "EARTH GLOBE ASIA-AUSTRALIA", "unicode": 127759},
  // {"name": "NEW MOON SYMBOL", "unicode": 127761},
  // {"name": "FIRST QUARTER MOON SYMBOL", "unicode": 127763},
  // {"name": "WAXING GIBBOUS MOON SYMBOL", "unicode": 127764},
  // {"name": "FULL MOON SYMBOL", "unicode": 127765},
  // {"name": "CRESCENT MOON", "unicode": 127769},
  // {"name": "FIRST QUARTER MOON WITH FACE", "unicode": 127771},
  // {"name": "GLOWING STAR", "unicode": 127775},
  // {"name": "SHOOTING STAR", "unicode": 127776},
  // {"name": "CHESTNUT", "unicode": 127792},
  // {"name": "SEEDLING", "unicode": 127793},
  // {"name": "PALM TREE", "unicode": 127796},
  // {"name": "CACTUS", "unicode": 127797},
  // {"name": "TULIP", "unicode": 127799},
  // {"name": "CHERRY BLOSSOM", "unicode": 127800},
  // {"name": "ROSE", "unicode": 127801},
  // {"name": "HIBISCUS", "unicode": 127802},
  // {"name": "SUNFLOWER", "unicode": 127803},
  // {"name": "BLOSSOM", "unicode": 127804},
  // {"name": "EAR OF MAIZE", "unicode": 127805},
  // {"name": "EAR OF RICE", "unicode": 127806},
  // {"name": "HERB", "unicode": 127807},
  // {"name": "FOUR LEAF CLOVER", "unicode": 127808},
  // {"name": "MAPLE LEAF", "unicode": 127809},
  // {"name": "FALLEN LEAF", "unicode": 127810},
  // {"name": "LEAF FLUTTERING IN WIND", "unicode": 127811},
  // {"name": "MUSHROOM", "unicode": 127812},
  // {"name": "TOMATO", "unicode": 127813},
  // {"name": "AUBERGINE", "unicode": 127814},
  // {"name": "GRAPES", "unicode": 127815},
  // {"name": "MELON", "unicode": 127816},
  // {"name": "WATERMELON", "unicode": 127817},
  // {"name": "TANGERINE", "unicode": 127818},
  // {"name": "BANANA", "unicode": 127820},
  // {"name": "PINEAPPLE", "unicode": 127821},
  // {"name": "RED APPLE", "unicode": 127822},
  // {"name": "GREEN APPLE", "unicode": 127823},
  // {"name": "PEACH", "unicode": 127825},
  // {"name": "CHERRIES", "unicode": 127826},
  // {"name": "STRAWBERRY", "unicode": 127827},
  // {"name": "HAMBURGER", "unicode": 127828},
  // {"name": "SLICE OF PIZZA", "unicode": 127829},
  // {"name": "MEAT ON BONE", "unicode": 127830},
  // {"name": "POULTRY LEG", "unicode": 127831},
  // {"name": "RICE CRACKER", "unicode": 127832},
  // {"name": "RICE BALL", "unicode": 127833},
  // {"name": "COOKED RICE", "unicode": 127834},
  // {"name": "CURRY AND RICE", "unicode": 127835},
  // {"name": "STEAMING BOWL", "unicode": 127836},
  // {"name": "SPAGHETTI", "unicode": 127837},
  // {"name": "BREAD", "unicode": 127838},
  // {"name": "FRENCH FRIES", "unicode": 127839},
  // {"name": "ROASTED SWEET POTATO", "unicode": 127840},
  // {"name": "DANGO", "unicode": 127841},
  // {"name": "ODEN", "unicode": 127842},
  // {"name": "SUSHI", "unicode": 127843},
  // {"name": "FRIED SHRIMP", "unicode": 127844},
  // {"name": "FISH CAKE WITH SWIRL DESIGN", "unicode": 127845},
  // {"name": "SOFT ICE CREAM", "unicode": 127846},
  // {"name": "SHAVED ICE", "unicode": 127847},
  // {"name": "ICE CREAM", "unicode": 127848},
  // {"name": "DOUGHNUT", "unicode": 127849},
  // {"name": "COOKIE", "unicode": 127850},
  // {"name": "CHOCOLATE BAR", "unicode": 127851},
  // {"name": "CANDY", "unicode": 127852},
  // {"name": "LOLLIPOP", "unicode": 127853},
  // {"name": "CUSTARD", "unicode": 127854},
  // {"name": "HONEY POT", "unicode": 127855},
  // {"name": "SHORTCAKE", "unicode": 127856},
  // {"name": "BENTO BOX", "unicode": 127857},
  // {"name": "POT OF FOOD", "unicode": 127858},
  // {"name": "COOKING", "unicode": 127859},
  // {"name": "FORK AND KNIFE", "unicode": 127860},
  // {"name": "TEACUP WITHOUT HANDLE", "unicode": 127861},
  // {"name": "SAKE BOTTLE AND CUP", "unicode": 127862},
  // {"name": "WINE GLASS", "unicode": 127863},
  // {"name": "COCKTAIL GLASS", "unicode": 127864},
  // {"name": "TROPICAL DRINK", "unicode": 127865},
  // {"name": "BEER MUG", "unicode": 127866},
  // {"name": "CLINKING BEER MUGS", "unicode": 127867},
  // {"name": "RIBBON", "unicode": 127872},
  // {"name": "WRAPPED PRESENT", "unicode": 127873},
  // {"name": "BIRTHDAY CAKE", "unicode": 127874},
  // {"name": "JACK-O-LANTERN", "unicode": 127875},
  // {"name": "CHRISTMAS TREE", "unicode": 127876},
  // {"name": "FATHER CHRISTMAS", "unicode": 127877},
  // {"name": "FIREWORKS", "unicode": 127878},
  // {"name": "FIREWORK SPARKLER", "unicode": 127879},
  // {"name": "BALLOON", "unicode": 127880},
  // {"name": "PARTY POPPER", "unicode": 127881},
  // {"name": "CONFETTI BALL", "unicode": 127882},
  // {"name": "TANABATA TREE", "unicode": 127883},
  // {"name": "CROSSED FLAGS", "unicode": 127884},
  // {"name": "PINE DECORATION", "unicode": 127885},
  // {"name": "JAPANESE DOLLS", "unicode": 127886},
  // {"name": "CARP STREAMER", "unicode": 127887},
  // {"name": "WIND CHIME", "unicode": 127888},
  // {"name": "MOON VIEWING CEREMONY", "unicode": 127889},
  // {"name": "SCHOOL SATCHEL", "unicode": 127890},
  // {"name": "GRADUATION CAP", "unicode": 127891},
  // {"name": "CAROUSEL HORSE", "unicode": 127904},
  // {"name": "FERRIS WHEEL", "unicode": 127905},
  // {"name": "ROLLER COASTER", "unicode": 127906},
  // {"name": "FISHING POLE AND FISH", "unicode": 127907},
  // {"name": "MICROPHONE", "unicode": 127908},
  // {"name": "MOVIE CAMERA", "unicode": 127909},
  // {"name": "CINEMA", "unicode": 127910},
  // {"name": "HEADPHONE", "unicode": 127911},
  // {"name": "ARTIST PALETTE", "unicode": 127912},
  // {"name": "TOP HAT", "unicode": 127913},
  // {"name": "CIRCUS TENT", "unicode": 127914},
  // {"name": "TICKET", "unicode": 127915},
  // {"name": "CLAPPER BOARD", "unicode": 127916},
  // {"name": "PERFORMING ARTS", "unicode": 127917},
  // {"name": "VIDEO GAME", "unicode": 127918},
  // {"name": "DIRECT HIT", "unicode": 127919},
  // {"name": "SLOT MACHINE", "unicode": 127920},
  // {"name": "BILLIARDS", "unicode": 127921},
  // {"name": "GAME DIE", "unicode": 127922},
  // {"name": "BOWLING", "unicode": 127923},
  // {"name": "FLOWER PLAYING CARDS", "unicode": 127924},
  // {"name": "MUSICAL NOTE", "unicode": 127925},
  // {"name": "MULTIPLE MUSICAL NOTES", "unicode": 127926},
  // {"name": "SAXOPHONE", "unicode": 127927},
  // {"name": "GUITAR", "unicode": 127928},
  // {"name": "MUSICAL KEYBOARD", "unicode": 127929},
  // {"name": "TRUMPET", "unicode": 127930},
  // {"name": "VIOLIN", "unicode": 127931},
  // {"name": "MUSICAL SCORE", "unicode": 127932},
  // {"name": "RUNNING SHIRT WITH SASH", "unicode": 127933},
  // {"name": "TENNIS RACQUET AND BALL", "unicode": 127934},
  // {"name": "SKI AND SKI BOOT", "unicode": 127935},
  // {"name": "BASKETBALL AND HOOP", "unicode": 127936},
  // {"name": "CHEQUERED FLAG", "unicode": 127937},
  // {"name": "SNOWBOARDER", "unicode": 127938},
  // {"name": "RUNNER", "unicode": 127939},
  // {"name": "SURFER", "unicode": 127940},
  // {"name": "TROPHY", "unicode": 127942},
  // {"name": "AMERICAN FOOTBALL", "unicode": 127944},
  // {"name": "SWIMMER", "unicode": 127946},
  // {"name": "HOUSE BUILDING", "unicode": 127968},
  // {"name": "HOUSE WITH GARDEN", "unicode": 127969},
  // {"name": "OFFICE BUILDING", "unicode": 127970},
  // {"name": "JAPANESE POST OFFICE", "unicode": 127971},
  // {"name": "HOSPITAL", "unicode": 127973},
  // {"name": "BANK", "unicode": 127974},
  // {"name": "AUTOMATED TELLER MACHINE", "unicode": 127975},
  // {"name": "HOTEL", "unicode": 127976},
  // {"name": "LOVE HOTEL", "unicode": 127977},
  // {"name": "CONVENIENCE STORE", "unicode": 127978},
  // {"name": "SCHOOL", "unicode": 127979},
  // {"name": "DEPARTMENT STORE", "unicode": 127980},
  // {"name": "FACTORY", "unicode": 127981},
  // {"name": "IZAKAYA LANTERN", "unicode": 127982},
  // {"name": "JAPANESE CASTLE", "unicode": 127983},
  // {"name": "EUROPEAN CASTLE", "unicode": 127984},
  // {"name": "SNAIL", "unicode": 128012},
  // {"name": "SNAKE", "unicode": 128013},
  // {"name": "HORSE", "unicode": 128014},
  // {"name": "SHEEP", "unicode": 128017},
  // {"name": "MONKEY", "unicode": 128018},
  // {"name": "CHICKEN", "unicode": 128020},
  // {"name": "BOAR", "unicode": 128023},
  // {"name": "ELEPHANT", "unicode": 128024},
  // {"name": "OCTOPUS", "unicode": 128025},
  // {"name": "SPIRAL SHELL", "unicode": 128026},
  // {"name": "BUG", "unicode": 128027},
  // {"name": "ANT", "unicode": 128028},
  // {"name": "HONEYBEE", "unicode": 128029},
  // {"name": "LADY BEETLE", "unicode": 128030},
  // {"name": "FISH", "unicode": 128031},
  // {"name": "TROPICAL FISH", "unicode": 128032},
  // {"name": "BLOWFISH", "unicode": 128033},
  // {"name": "TURTLE", "unicode": 128034},
  // {"name": "HATCHING CHICK", "unicode": 128035},
  // {"name": "BABY CHICK", "unicode": 128036},
  // {"name": "FRONT-FACING BABY CHICK", "unicode": 128037},
  // {"name": "BIRD", "unicode": 128038},
  // {"name": "PENGUIN", "unicode": 128039},
  // {"name": "KOALA", "unicode": 128040},
  // {"name": "POODLE", "unicode": 128041},
  // {"name": "BACTRIAN CAMEL", "unicode": 128043},
  // {"name": "DOLPHIN", "unicode": 128044},
  // {"name": "MOUSE FACE", "unicode": 128045},
  // {"name": "COW FACE", "unicode": 128046},
  // {"name": "TIGER FACE", "unicode": 128047},
  // {"name": "RABBIT FACE", "unicode": 128048},
  // {"name": "CAT FACE", "unicode": 128049},
  // {"name": "DRAGON FACE", "unicode": 128050},
  // {"name": "SPOUTING WHALE", "unicode": 128051},
  // {"name": "HORSE FACE", "unicode": 128052},
  // {"name": "MONKEY FACE", "unicode": 128053},
  // {"name": "DOG FACE", "unicode": 128054},
  // {"name": "PIG FACE", "unicode": 128055},
  // {"name": "FROG FACE", "unicode": 128056},
  // {"name": "HAMSTER FACE", "unicode": 128057},
  // {"name": "WOLF FACE", "unicode": 128058},
  // {"name": "BEAR FACE", "unicode": 128059},
  // {"name": "PANDA FACE", "unicode": 128060},
  // {"name": "PIG NOSE", "unicode": 128061},
  // {"name": "PAW PRINTS", "unicode": 128062},
  // {"name": "EYES", "unicode": 128064},
  // {"name": "EAR", "unicode": 128066},
  // {"name": "NOSE", "unicode": 128067},
  // {"name": "MOUTH", "unicode": 128068},
  // {"name": "TONGUE", "unicode": 128069},
  // {"name": "WHITE UP POINTING BACKHAND INDEX", "unicode": 128070},
  // {"name": "WHITE DOWN POINTING BACKHAND INDEX", "unicode": 128071},
  // {"name": "WHITE LEFT POINTING BACKHAND INDEX", "unicode": 128072},
  // {"name": "WHITE RIGHT POINTING BACKHAND INDEX", "unicode": 128073},
  // {"name": "FISTED HAND SIGN", "unicode": 128074},
  // {"name": "WAVING HAND SIGN", "unicode": 128075},
  // {"name": "OK HAND SIGN", "unicode": 128076},
  // {"name": "THUMBS UP SIGN", "unicode": 128077},
  // {"name": "THUMBS DOWN SIGN", "unicode": 128078},
  // {"name": "CLAPPING HANDS SIGN", "unicode": 128079},
  // {"name": "OPEN HANDS SIGN", "unicode": 128080},
  // {"name": "CROWN", "unicode": 128081},
  // {"name": "WOMANS HAT", "unicode": 128082},
  // {"name": "EYEGLASSES", "unicode": 128083},
  // {"name": "NECKTIE", "unicode": 128084},
  // {"name": "T-SHIRT", "unicode": 128085},
  // {"name": "JEANS", "unicode": 128086},
  // {"name": "DRESS", "unicode": 128087},
  // {"name": "KIMONO", "unicode": 128088},
  // {"name": "BIKINI", "unicode": 128089},
  // {"name": "WOMANS CLOTHES", "unicode": 128090},
  // {"name": "PURSE", "unicode": 128091},
  // {"name": "HANDBAG", "unicode": 128092},
  // {"name": "POUCH", "unicode": 128093},
  // {"name": "MANS SHOE", "unicode": 128094},
  // {"name": "ATHLETIC SHOE", "unicode": 128095},
  // {"name": "HIGH-HEELED SHOE", "unicode": 128096},
  // {"name": "WOMANS SANDAL", "unicode": 128097},
  // {"name": "WOMANS BOOTS", "unicode": 128098},
  // {"name": "FOOTPRINTS", "unicode": 128099},
  // {"name": "BUST IN SILHOUETTE", "unicode": 128100},
  // {"name": "BOY", "unicode": 128102},
  // {"name": "GIRL", "unicode": 128103},
  // {"name": "MAN", "unicode": 128104},
  // {"name": "WOMAN", "unicode": 128105},
  // {"name": "FAMILY", "unicode": 128106},
  // {"name": "MAN AND WOMAN HOLDING HANDS", "unicode": 128107},
  // {"name": "POLICE OFFICER", "unicode": 128110},
  // {"name": "WOMAN WITH BUNNY EARS", "unicode": 128111},
  // {"name": "BRIDE WITH VEIL", "unicode": 128112},
  // {"name": "PERSON WITH BLOND HAIR", "unicode": 128113},
  // {"name": "MAN WITH GUA PI MAO", "unicode": 128114},
  // {"name": "MAN WITH TURBAN", "unicode": 128115},
  // {"name": "OLDER MAN", "unicode": 128116},
  // {"name": "OLDER WOMAN", "unicode": 128117},
  // {"name": "BABY", "unicode": 128118},
  // {"name": "CONSTRUCTION WORKER", "unicode": 128119},
  // {"name": "PRINCESS", "unicode": 128120},
  // {"name": "JAPANESE OGRE", "unicode": 128121},
  // {"name": "JAPANESE GOBLIN", "unicode": 128122},
  // {"name": "GHOST", "unicode": 128123},
  // {"name": "BABY ANGEL", "unicode": 128124},
  // {"name": "EXTRATERRESTRIAL ALIEN", "unicode": 128125},
  // {"name": "ALIEN MONSTER", "unicode": 128126},
  // {"name": "IMP", "unicode": 128127},
  // {"name": "SKULL", "unicode": 128128},
  // {"name": "INFORMATION DESK PERSON", "unicode": 128129},
  // {"name": "GUARDSMAN", "unicode": 128130},
  // {"name": "DANCER", "unicode": 128131},
  // {"name": "LIPSTICK", "unicode": 128132},
  // {"name": "NAIL POLISH", "unicode": 128133},
  // {"name": "FACE MASSAGE", "unicode": 128134},
  // {"name": "HAIRCUT", "unicode": 128135},
  // {"name": "BARBER POLE", "unicode": 128136},
  // {"name": "SYRINGE", "unicode": 128137},
  // {"name": "PILL", "unicode": 128138},
  // {"name": "KISS MARK", "unicode": 128139},
  // {"name": "LOVE LETTER", "unicode": 128140},
  // {"name": "RING", "unicode": 128141},
  // {"name": "GEM STONE", "unicode": 128142},
  // {"name": "KISS", "unicode": 128143},
  // {"name": "BOUQUET", "unicode": 128144},
  // {"name": "COUPLE WITH HEART", "unicode": 128145},
  // {"name": "WEDDING", "unicode": 128146},
  // {"name": "BEATING HEART", "unicode": 128147},
  // {"name": "BROKEN HEART", "unicode": 128148},
  // {"name": "TWO HEARTS", "unicode": 128149},
  // {"name": "SPARKLING HEART", "unicode": 128150},
  // {"name": "GROWING HEART", "unicode": 128151},
  // {"name": "HEART WITH ARROW", "unicode": 128152},
  // {"name": "BLUE HEART", "unicode": 128153},
  // {"name": "GREEN HEART", "unicode": 128154},
  // {"name": "YELLOW HEART", "unicode": 128155},
  // {"name": "PURPLE HEART", "unicode": 128156},
  // {"name": "HEART WITH RIBBON", "unicode": 128157},
  // {"name": "REVOLVING HEARTS", "unicode": 128158},
  // {"name": "HEART DECORATION", "unicode": 128159},
  // {"name": "DIAMOND SHAPE WITH A DOT INSIDE", "unicode": 128160},
  // {"name": "ELECTRIC LIGHT BULB", "unicode": 128161},
  // {"name": "ANGER SYMBOL", "unicode": 128162},
  // {"name": "BOMB", "unicode": 128163},
  // {"name": "SLEEPING SYMBOL", "unicode": 128164},
  // {"name": "COLLISION SYMBOL", "unicode": 128165},
  // {"name": "SPLASHING SWEAT SYMBOL", "unicode": 128166},
  // {"name": "DROPLET", "unicode": 128167},
  // {"name": "DASH SYMBOL", "unicode": 128168},
  // {"name": "PILE OF POO", "unicode": 128169},
  // {"name": "FLEXED BICEPS", "unicode": 128170},
  // {"name": "DIZZY SYMBOL", "unicode": 128171},
  // {"name": "SPEECH BALLOON", "unicode": 128172},
  // {"name": "WHITE FLOWER", "unicode": 128174},
  // {"name": "HUNDRED POINTS SYMBOL", "unicode": 128175},
  // {"name": "MONEY BAG", "unicode": 128176},
  // {"name": "CURRENCY EXCHANGE", "unicode": 128177},
  // {"name": "HEAVY DOLLAR SIGN", "unicode": 128178},
  // {"name": "CREDIT CARD", "unicode": 128179},
  // {"name": "BANKNOTE WITH YEN SIGN", "unicode": 128180},
  // {"name": "BANKNOTE WITH DOLLAR SIGN", "unicode": 128181},
  // {"name": "MONEY WITH WINGS", "unicode": 128184},
  // {"name": "CHART WITH UPWARDS TREND AND YEN SIGN", "unicode": 128185},
  // {"name": "SEAT", "unicode": 128186},
  // {"name": "PERSONAL COMPUTER", "unicode": 128187},
  // {"name": "BRIEFCASE", "unicode": 128188},
  // {"name": "MINIDISC", "unicode": 128189},
  // {"name": "FLOPPY DISK", "unicode": 128190},
  // {"name": "OPTICAL DISC", "unicode": 128191},
  // {"name": "DVD", "unicode": 128192},
  // {"name": "FILE FOLDER", "unicode": 128193},
  // {"name": "OPEN FILE FOLDER", "unicode": 128194},
  // {"name": "PAGE WITH CURL", "unicode": 128195},
  // {"name": "PAGE FACING UP", "unicode": 128196},
  // {"name": "CALENDAR", "unicode": 128197},
  // {"name": "TEAR-OFF CALENDAR", "unicode": 128198},
  // {"name": "CARD INDEX", "unicode": 128199},
  // {"name": "CHART WITH UPWARDS TREND", "unicode": 128200},
  // {"name": "CHART WITH DOWNWARDS TREND", "unicode": 128201},
  // {"name": "BAR CHART", "unicode": 128202},
  // {"name": "CLIPBOARD", "unicode": 128203},
  // {"name": "PUSHPIN", "unicode": 128204},
  // {"name": "ROUND PUSHPIN", "unicode": 128205},
  // {"name": "PAPERCLIP", "unicode": 128206},
  // {"name": "STRAIGHT RULER", "unicode": 128207},
  // {"name": "TRIANGULAR RULER", "unicode": 128208},
  // {"name": "BOOKMARK TABS", "unicode": 128209},
  // {"name": "LEDGER", "unicode": 128210},
  // {"name": "NOTEBOOK", "unicode": 128211},
  // {"name": "NOTEBOOK WITH DECORATIVE COVER", "unicode": 128212},
  // {"name": "CLOSED BOOK", "unicode": 128213},
  // {"name": "OPEN BOOK", "unicode": 128214},
  // {"name": "GREEN BOOK", "unicode": 128215},
  // {"name": "BLUE BOOK", "unicode": 128216},
  // {"name": "ORANGE BOOK", "unicode": 128217},
  // {"name": "BOOKS", "unicode": 128218},
  // {"name": "NAME BADGE", "unicode": 128219},
  // {"name": "SCROLL", "unicode": 128220},
  // {"name": "MEMO", "unicode": 128221},
  // {"name": "TELEPHONE RECEIVER", "unicode": 128222},
  // {"name": "PAGER", "unicode": 128223},
  // {"name": "FAX MACHINE", "unicode": 128224},
  // {"name": "SATELLITE ANTENNA", "unicode": 128225},
  // {"name": "PUBLIC ADDRESS LOUDSPEAKER", "unicode": 128226},
  // {"name": "CHEERING MEGAPHONE", "unicode": 128227},
  // {"name": "OUTBOX TRAY", "unicode": 128228},
  // {"name": "INBOX TRAY", "unicode": 128229},
  // {"name": "PACKAGE", "unicode": 128230},
  // {"name": "E-MAIL SYMBOL", "unicode": 128231},
  // {"name": "INCOMING ENVELOPE", "unicode": 128232},
  // {"name": "ENVELOPE WITH DOWNWARDS ARROW ABOVE", "unicode": 128233},
  // {"name": "CLOSED MAILBOX WITH LOWERED FLAG", "unicode": 128234},
  // {"name": "CLOSED MAILBOX WITH RAISED FLAG", "unicode": 128235},
  // {"name": "POSTBOX", "unicode": 128238},
  // {"name": "NEWSPAPER", "unicode": 128240},
  // {"name": "MOBILE PHONE", "unicode": 128241},
  // {"name": "MOBILE PHONE WITH RIGHTWARDS ARROW AT LEFT", "unicode": 128242},
  // {"name": "VIBRATION MODE", "unicode": 128243},
  // {"name": "MOBILE PHONE OFF", "unicode": 128244},
  // {"name": "ANTENNA WITH BARS", "unicode": 128246},
  // {"name": "CAMERA", "unicode": 128247},
  // {"name": "VIDEO CAMERA", "unicode": 128249},
  // {"name": "TELEVISION", "unicode": 128250},
  // {"name": "RADIO", "unicode": 128251},
  // {"name": "VIDEOCASSETTE", "unicode": 128252},
  // {
  //   "name": "CLOCKWISE DOWNWARDS AND UPWARDS OPEN CIRCLE ARROWS",
  //   "unicode": 128259
  // },
  // {"name": "SPEAKER WITH THREE SOUND WAVES", "unicode": 128266},
  // {"name": "BATTERY", "unicode": 128267},
  // {"name": "ELECTRIC PLUG", "unicode": 128268},
  // {"name": "LEFT-POINTING MAGNIFYING GLASS", "unicode": 128269},
  // {"name": "RIGHT-POINTING MAGNIFYING GLASS", "unicode": 128270},
  // {"name": "LOCK WITH INK PEN", "unicode": 128271},
  // {"name": "CLOSED LOCK WITH KEY", "unicode": 128272},
  // {"name": "KEY", "unicode": 128273},
  // {"name": "LOCK", "unicode": 128274},
  // {"name": "OPEN LOCK", "unicode": 128275},
  // {"name": "BELL", "unicode": 128276},
  // {"name": "BOOKMARK", "unicode": 128278},
  // {"name": "LINK SYMBOL", "unicode": 128279},
  // {"name": "RADIO BUTTON", "unicode": 128280},
  // {"name": "BACK WITH LEFTWARDS ARROW ABOVE", "unicode": 128281},
  // {"name": "END WITH LEFTWARDS ARROW ABOVE", "unicode": 128282},
  // {
  //   "name": "ON WITH EXCLAMATION MARK WITH LEFT RIGHT ARROW ABOVE",
  //   "unicode": 128283
  // },
  // {"name": "SOON WITH RIGHTWARDS ARROW ABOVE", "unicode": 128284},
  // {"name": "TOP WITH UPWARDS ARROW ABOVE", "unicode": 128285},
  // {"name": "NO ONE UNDER EIGHTEEN SYMBOL", "unicode": 128286},
  // {"name": "KEYCAP TEN", "unicode": 128287},
  // {"name": "INPUT SYMBOL FOR LATIN CAPITAL LETTERS", "unicode": 128288},
  // {"name": "INPUT SYMBOL FOR LATIN SMALL LETTERS", "unicode": 128289},
  // {"name": "INPUT SYMBOL FOR NUMBERS", "unicode": 128290},
  // {"name": "INPUT SYMBOL FOR SYMBOLS", "unicode": 128291},
  // {"name": "INPUT SYMBOL FOR LATIN LETTERS", "unicode": 128292},
  // {"name": "FIRE", "unicode": 128293},
  // {"name": "ELECTRIC TORCH", "unicode": 128294},
  // {"name": "WRENCH", "unicode": 128295},
  // {"name": "HAMMER", "unicode": 128296},
  // {"name": "NUT AND BOLT", "unicode": 128297},
  // {"name": "HOCHO", "unicode": 128298},
  // {"name": "PISTOL", "unicode": 128299},
  // {"name": "CRYSTAL BALL", "unicode": 128302},
  // {"name": "SIX POINTED STAR WITH MIDDLE DOT", "unicode": 128303},
  // {"name": "JAPANESE SYMBOL FOR BEGINNER", "unicode": 128304},
  // {"name": "TRIDENT EMBLEM", "unicode": 128305},
  // {"name": "BLACK SQUARE BUTTON", "unicode": 128306},
  // {"name": "WHITE SQUARE BUTTON", "unicode": 128307},
  // {"name": "LARGE RED CIRCLE", "unicode": 128308},
  // {"name": "LARGE BLUE CIRCLE", "unicode": 128309},
  // {"name": "LARGE ORANGE DIAMOND", "unicode": 128310},
  // {"name": "LARGE BLUE DIAMOND", "unicode": 128311},
  // {"name": "SMALL ORANGE DIAMOND", "unicode": 128312},
  // {"name": "SMALL BLUE DIAMOND", "unicode": 128313},
  // {"name": "UP-POINTING RED TRIANGLE", "unicode": 128314},
  // {"name": "DOWN-POINTING RED TRIANGLE", "unicode": 128315},
  // {"name": "UP-POINTING SMALL RED TRIANGLE", "unicode": 128316},
  // {"name": "DOWN-POINTING SMALL RED TRIANGLE", "unicode": 128317},
  // {"name": "CLOCK FACE ONE OCLOCK", "unicode": 128336},
  // {"name": "CLOCK FACE TWO OCLOCK", "unicode": 128337},
  // {"name": "CLOCK FACE THREE OCLOCK", "unicode": 128338},
  // {"name": "CLOCK FACE FOUR OCLOCK", "unicode": 128339},
  // {"name": "CLOCK FACE FIVE OCLOCK", "unicode": 128340},
  // {"name": "CLOCK FACE SIX OCLOCK", "unicode": 128341},
  // {"name": "CLOCK FACE SEVEN OCLOCK", "unicode": 128342},
  // {"name": "CLOCK FACE EIGHT OCLOCK", "unicode": 128343},
  // {"name": "CLOCK FACE NINE OCLOCK", "unicode": 128344},
  // {"name": "CLOCK FACE TEN OCLOCK", "unicode": 128345},
  // {"name": "CLOCK FACE ELEVEN OCLOCK", "unicode": 128346},
  // {"name": "CLOCK FACE TWELVE OCLOCK", "unicode": 128347},
  // {"name": "MOUNT FUJI", "unicode": 128507},
  // {"name": "TOKYO TOWER", "unicode": 128508},
  // {"name": "STATUE OF LIBERTY", "unicode": 128509},
  // {"name": "SILHOUETTE OF JAPAN", "unicode": 128510},
  // {"name": "MOYAI", "unicode": 128511},
  // {"name": "GRINNING FACE", "unicode": 128512},
  // {"name": "SMILING FACE WITH HALO", "unicode": 128519},
  // {"name": "SMILING FACE WITH HORNS", "unicode": 128520},
  // {"name": "SMILING FACE WITH SUNGLASSES", "unicode": 128526},
  // {"name": "NEUTRAL FACE", "unicode": 128528},
  // {"name": "EXPRESSIONLESS FACE", "unicode": 128529},
  // {"name": "CONFUSED FACE", "unicode": 128533},
  // {"name": "KISSING FACE", "unicode": 128535},
  // {"name": "KISSING FACE WITH SMILING EYES", "unicode": 128537},
  // {"name": "FACE WITH STUCK-OUT TONGUE", "unicode": 128539},
  // {"name": "WORRIED FACE", "unicode": 128543},
  // {"name": "FROWNING FACE WITH OPEN MOUTH", "unicode": 128550},
  // {"name": "ANGUISHED FACE", "unicode": 128551},
  // {"name": "GRIMACING FACE", "unicode": 128556},
  // {"name": "FACE WITH OPEN MOUTH", "unicode": 128558},
  // {"name": "HUSHED FACE", "unicode": 128559},
  // {"name": "SLEEPING FACE", "unicode": 128564},
  // {"name": "FACE WITHOUT MOUTH", "unicode": 128566},
  // {"name": "HELICOPTER", "unicode": 128641},
  // {"name": "STEAM LOCOMOTIVE", "unicode": 128642},
  // {"name": "TRAIN", "unicode": 128646},
  // {"name": "LIGHT RAIL", "unicode": 128648},
  // {"name": "TRAM", "unicode": 128650},
  // {"name": "ONCOMING BUS", "unicode": 128653},
  // {"name": "TROLLEYBUS", "unicode": 128654},
  // {"name": "MINIBUS", "unicode": 128656},
  // {"name": "ONCOMING POLICE CAR", "unicode": 128660},
  // {"name": "ONCOMING TAXI", "unicode": 128662},
  // {"name": "ONCOMING AUTOMOBILE", "unicode": 128664},
  // {"name": "ARTICULATED LORRY", "unicode": 128667},
  // {"name": "TRACTOR", "unicode": 128668},
  // {"name": "MONORAIL", "unicode": 128669},
  // {"name": "MOUNTAIN RAILWAY", "unicode": 128670},
  // {"name": "SUSPENSION RAILWAY", "unicode": 128671},
  // {"name": "MOUNTAIN CABLEWAY", "unicode": 128672},
  // {"name": "AERIAL TRAMWAY", "unicode": 128673},
  // {"name": "ROWBOAT", "unicode": 128675},
  // {"name": "VERTICAL TRAFFIC LIGHT", "unicode": 128678},
  // {"name": "PUT LITTER IN ITS PLACE SYMBOL", "unicode": 128686},
  // {"name": "DO NOT LITTER SYMBOL", "unicode": 128687},
  // {"name": "POTABLE WATER SYMBOL", "unicode": 128688},
  // {"name": "NON-POTABLE WATER SYMBOL", "unicode": 128689},
  // {"name": "NO BICYCLES", "unicode": 128691},
  // {"name": "BICYCLIST", "unicode": 128692},
  // {"name": "MOUNTAIN BICYCLIST", "unicode": 128693},
  // {"name": "NO PEDESTRIANS", "unicode": 128695},
  // {"name": "CHILDREN CROSSING", "unicode": 128696},
  // {"name": "SHOWER", "unicode": 128703},
  // {"name": "BATHTUB", "unicode": 128705},
  // {"name": "PASSPORT CONTROL", "unicode": 128706},
  // {"name": "CUSTOMS", "unicode": 128707},
  // {"name": "BAGGAGE CLAIM", "unicode": 128708},
  // {"name": "LEFT LUGGAGE", "unicode": 128709},
  // {"name": "EARTH GLOBE EUROPE-AFRICA", "unicode": 127757},
  // {"name": "EARTH GLOBE AMERICAS", "unicode": 127758},
  // {"name": "GLOBE WITH MERIDIANS", "unicode": 127760},
  // {"name": "WAXING CRESCENT MOON SYMBOL", "unicode": 127762},
  // {"name": "WANING GIBBOUS MOON SYMBOL", "unicode": 127766},
  // {"name": "LAST QUARTER MOON SYMBOL", "unicode": 127767},
  // {"name": "WANING CRESCENT MOON SYMBOL", "unicode": 127768},
  // {"name": "NEW MOON WITH FACE", "unicode": 127770},
  // {"name": "LAST QUARTER MOON WITH FACE", "unicode": 127772},
  // {"name": "FULL MOON WITH FACE", "unicode": 127773},
  // {"name": "SUN WITH FACE", "unicode": 127774},
  // {"name": "EVERGREEN TREE", "unicode": 127794},
  // {"name": "DECIDUOUS TREE", "unicode": 127795},
  // {"name": "LEMON", "unicode": 127819},
  // {"name": "PEAR", "unicode": 127824},
  // {"name": "BABY BOTTLE", "unicode": 127868},
  // {"name": "HORSE RACING", "unicode": 127943},
  // {"name": "RUGBY FOOTBALL", "unicode": 127945},
  // {"name": "EUROPEAN POST OFFICE", "unicode": 127972},
  // {"name": "RAT", "unicode": 128000},
  // {"name": "MOUSE", "unicode": 128001},
  // {"name": "OX", "unicode": 128002},
  // {"name": "WATER BUFFALO", "unicode": 128003},
  // {"name": "COW", "unicode": 128004},
  // {"name": "TIGER", "unicode": 128005},
  // {"name": "LEOPARD", "unicode": 128006},
  // {"name": "RABBIT", "unicode": 128007},
  // {"name": "CAT", "unicode": 128008},
  // {"name": "DRAGON", "unicode": 128009},
  // {"name": "CROCODILE", "unicode": 128010},
  // {"name": "WHALE", "unicode": 128011},
  // {"name": "RAM", "unicode": 128015},
  // {"name": "GOAT", "unicode": 128016},
  // {"name": "ROOSTER", "unicode": 128019},
  // {"name": "DOG", "unicode": 128021},
  // {"name": "PIG", "unicode": 128022},
  // {"name": "DROMEDARY CAMEL", "unicode": 128042},
  // {"name": "BUSTS IN SILHOUETTE", "unicode": 128101},
  // {"name": "TWO MEN HOLDING HANDS", "unicode": 128108},
  // {"name": "TWO WOMEN HOLDING HANDS", "unicode": 128109},
  // {"name": "THOUGHT BALLOON", "unicode": 128173},
  // {"name": "BANKNOTE WITH EURO SIGN", "unicode": 128182},
  // {"name": "BANKNOTE WITH POUND SIGN", "unicode": 128183},
  // {"name": "OPEN MAILBOX WITH RAISED FLAG", "unicode": 128236},
  // {"name": "OPEN MAILBOX WITH LOWERED FLAG", "unicode": 128237},
  // {"name": "POSTAL HORN", "unicode": 128239},
  // {"name": "NO MOBILE PHONES", "unicode": 128245},
  // {"name": "TWISTED RIGHTWARDS ARROWS", "unicode": 128256},
  // {
  //   "name": "CLOCKWISE RIGHTWARDS AND LEFTWARDS OPEN CIRCLE ARROWS",
  //   "unicode": 128257
  // },
  // {
  //   "name":
  //       "CLOCKWISE RIGHTWARDS AND LEFTWARDS OPEN CIRCLE ARROWS WITH CIRCLED ONE OVERLAY",
  //   "unicode": 128258
  // },
  // {
  //   "name": "ANTICLOCKWISE DOWNWARDS AND UPWARDS OPEN CIRCLE ARROWS",
  //   "unicode": 128260
  // },
  // {"name": "LOW BRIGHTNESS SYMBOL", "unicode": 128261},
  // {"name": "HIGH BRIGHTNESS SYMBOL", "unicode": 128262},
  // {"name": "SPEAKER WITH CANCELLATION STROKE", "unicode": 128263},
  // {"name": "SPEAKER WITH ONE SOUND WAVE", "unicode": 128265},
  // {"name": "BELL WITH CANCELLATION STROKE", "unicode": 128277},
  // {"name": "MICROSCOPE", "unicode": 128300},
  // {"name": "TELESCOPE", "unicode": 128301},
  // {"name": "CLOCK FACE ONE-THIRTY", "unicode": 128348},
  // {"name": "CLOCK FACE TWO-THIRTY", "unicode": 128349},
  // {"name": "CLOCK FACE THREE-THIRTY", "unicode": 128350},
  // {"name": "CLOCK FACE FOUR-THIRTY", "unicode": 128351},
  // {"name": "CLOCK FACE FIVE-THIRTY", "unicode": 128352},
  // {"name": "CLOCK FACE SIX-THIRTY", "unicode": 128353},
  // {"name": "CLOCK FACE SEVEN-THIRTY", "unicode": 128354},
  // {"name": "CLOCK FACE EIGHT-THIRTY", "unicode": 128355},
  // {"name": "CLOCK FACE NINE-THIRTY", "unicode": 128356},
  // {"name": "CLOCK FACE TEN-THIRTY", "unicode": 128357},
  // {"name": "CLOCK FACE ELEVEN-THIRTY", "unicode": 128358},
  // {"name": "CLOCK FACE TWELVE-THIRTY", "unicode": 128359}
];

class EmojiItem extends StatelessWidget {
  EmojiItem({name, unicode, toUser, type, close}) {
    this.name = name;
    this.unicode = unicode;
    this.toUser = toUser;
    this.type = type;
    this.close = close;
  }
  String name;
  int unicode;
  String toUser;
  int type;
  Function close;
  @override
  Widget build(BuildContext context) {
    return InkWell(
      onTap: () async {
        print("表情touser$toUser");
        V2TimValueCallback<V2TimMessage> sendRes;
        if (type == 1) {
          sendRes = await TencentImSDKPlugin.v2TIMManager.sendC2CTextMessage(
              text: String.fromCharCode(unicode), userID: toUser);
        } else if (type == 2) {
          sendRes = await TencentImSDKPlugin.v2TIMManager.sendGroupTextMessage(
            text: String.fromCharCode(unicode),
            groupID: toUser,
            priority: 0,
          );
        }
        if (sendRes.code == 0) {
          String key = (type == 1 ? "c2c_$toUser" : "group_$toUser");
          print("key $key");
          List<V2TimMessage> list = new List<V2TimMessage>();
          list.add(sendRes.data);
          Provider.of<CurrentMessageListModel>(context, listen: false)
              .addMessage(key, list);
          print('发送成功');
          close();
        } else {
          print('发送失败${sendRes.desc}');
        }
      },
      child: Container(
        child: Text(
          String.fromCharCode(unicode),
          style: TextStyle(
            fontSize: 26,
          ),
        ),
      ),
    );
  }
}
